Declare Function Escape Lib "GDI" (ByVal hDC%, ByVal nEscape%, ByVal nCount%, lplnData As Any, lpOutData As Any) As Integer
Declare Function GetDeviceCaps Lib "GDI" (ByVal hDC%, ByVal nIndex%) As Integer

'-----------------------------------------------------------------------------------------------
'Set this const for Millimeter, Centimeter or Inch

Global Const UNITSPERINCH = 2.54         '25.4 for Millimeter, 2.54 for Centimeter, 1.0 for Inch
'-----------------------------------------------------------------------------------------------

Global Const GETPHYSPAGESIZE = 12       'Get the physical page size
Global Const GETPRINTINGOFFSET = 13     'Get offset (upper-left corner) from printable area
Global Const LOGPIXELSX = 88            'Get pixels per logical inch along the display width
Global Const LOGPIXELSY = 90            'Get pixels per logical inch along the display height

Type T_Pt
    X As Integer
    Y As Integer
End Type

Global PrintOffset As T_Pt
Global PageSize As T_Pt

Function MarginBottom () As Single
'Get bottom margin of non-printable area

Dim PSM As Integer

PSM = Printer.ScaleMode

Printer.ScaleMode = 5

MarginBottom = PageHeight() - MarginTop() - Printer.ScaleHeight * UNITSPERINCH

Printer.ScaleMode = PSM

End Function

Function MarginLeft () As Single
'Get left margin of non-printable area

Dim API As Integer

API = Escape(Printer.hDC, GETPRINTINGOFFSET, 0, 0, PrintOffset)

MarginLeft = PrintOffset.X / GetDeviceCaps(Printer.hDC, LOGPIXELSX) * UNITSPERINCH

End Function

Function MarginRight () As Single
'Get right margin of non-printable area

Dim PSM As Integer

PSM = Printer.ScaleMode

Printer.ScaleMode = 5

MarginRight = PageWidth() - MarginLeft() - Printer.ScaleWidth * UNITSPERINCH

Printer.ScaleMode = PSM

End Function

Function MarginTop () As Single
'Get top margin of non-printable area

Dim API As Integer

API = Escape(Printer.hDC, GETPRINTINGOFFSET, 0, 0, PrintOffset)

MarginTop = PrintOffset.Y / GetDeviceCaps(Printer.hDC, LOGPIXELSY) * UNITSPERINCH

End Function

Function PageHeight () As Single
'Get height of page size

Dim API As Integer

API = Escape(Printer.hDC, GETPHYSPAGESIZE, 0, 0, PageSize)

PageHeight = PageSize.Y / GetDeviceCaps(Printer.hDC, LOGPIXELSY) * UNITSPERINCH

End Function

Function PageWidth () As Single
'Get width of page size

Dim API As Integer

API = Escape(Printer.hDC, GETPHYSPAGESIZE, 0, 0, PageSize)

PageWidth = PageSize.X / GetDeviceCaps(Printer.hDC, LOGPIXELSX) * UNITSPERINCH

End Function

